/*Rapidly put together by Craig Stanton  http://craig.stanton.net.nz */

var savedLocation=""
var savedCategory=""
//var theRSSURL = " http://newyork.craigslist.org/zip/index.rss";		
var theRSSURL = "";	
var locationKey = 'savedLocation';
var categoryKey = 'savedCategory';
//var fetchingNotice = '<div id="fetchingNotice"><img src=Images/spinner.gif> fetching data now</div>';
var feedChanged = true;

function RSSParsed(){
	document.getElementById("fetchingNotice").style.display = 'none';
	newContent = document.getElementById('feedcontainer');
	newContent.style.display = 'block';
	calculateAndShowThumb(newContent);
}

function clearScroll(){
	newContent = document.getElementById('feedcontainer');
	newContent.style.display = 'block';
	calculateAndShowThumb(newContent);
}

function createURL(){
	theForm = document.optionForm;
	theLocation = theForm.location.value;
	theCategory = theForm.category.value;

	return "http://"+ theLocation+ ".craigslist.org/"+ theCategory +"/index.rss"
}
function createRealURL(){
	theForm = document.optionForm;
	theLocation = theForm.location.value;
	theCategory = theForm.category.value;

	return "http://"+ theLocation+ ".craigslist.org/"+ theCategory
}

 function openURL(url) {
        if (window.widget) {
            widget.openURL(url);
        }
        else {
            window.location.href = url;
        }
    }

function upDateFeedInfo(){
	theForm = document.optionForm;
	theLocation = theForm.location.options[theForm.location.selectedIndex].name;
	theCategory = theForm.category.options[theForm.category.selectedIndex].name;
	theLocationName = theForm.location.options[theForm.location.selectedIndex].name;
	theCategoryName = theForm.category.options[theForm.category.selectedIndex].name;
	
	if ((theLocation == '') || (theCategory == '')){
		document.getElementById("feedInfo").innerHTML = '';
		return false;
	}else{
		document.getElementById("feedInfo").innerHTML = "<b><a onclick=openURL(\'"+createRealURL()+"\')>"+theCategoryName + " / " + theLocationName+".</a></b>";
		return true;
	}
}

function setup(){
	clearScroll();
	var optionsButton = document.getElementById('options_button');
	createGenericButton (optionsButton, 'Please choose your location and category', showPrefs);

	var doneButton = document.getElementById('done_button');
	createGenericButton (doneButton, 'Done', hidePrefs);

	restoreSavedPrefs();
	Go();
}

function Go(){
	document.getElementById("feedcontainer").innerHTML = '';
	clearScroll();

	if (upDateFeedInfo()) {
		optionsButton = document.getElementById('options_button');
		optionsButton.style.display="none";	
		document.getElementById("fetchingNotice").style.display = 'block';
		if(importXML(createURL(),'parseRSS',false,2000)){
			window.myInterval=window.setInterval('importXML(createURL(),\'parseRSS\',false,2000);',60000);
		}
	}else{
		
		document.getElementById("fetchingNotice").style.display = 'none';
		optionsButton = document.getElementById('options_button');
		optionsButton.style.display="block";	
	}
}

function saveLocationPref(){
	if (window.widget){
		widget.setPreferenceForKey(document.optionForm.location.value, locationKey);
	}
}

function saveCategoryPref(){
	if (window.widget){
		widget.setPreferenceForKey(document.optionForm.category.value, categoryKey);
	}
}

function restoreSavedPrefs(){
	if (window.widget){
		savedLocationValue = widget.preferenceForKey(locationKey);
		savedCategoryValue = widget.preferenceForKey(categoryKey);

		if (savedLocationValue != ''){
			for( i = 0; i < document.optionForm.location.length; i++){
				if (document.optionForm.location.options[i].value == savedLocationValue){
					document.optionForm.location.options[i].selected = true;
				}
			}
		}

		if (savedCategoryValue != ''){
			for( i = 0; i < document.optionForm.category.length; i++){
				if (document.optionForm.category.options[i].value == savedCategoryValue){
					document.optionForm.category.options[i].selected = true;
				} 
			}
		}

	}
}
